/* \mainpage

Binc IMAP - fast, secure, and reliable email retrieval
======================================================

WHAT IT IS:
----------
- BincIMAP 2.0.x is a fork of Andreas Aardal Hanssen's 
  C++ BincIMAP 1.3.4 implementation; but now based on UCSPI-SSL.
- Therefore, it comes with IPv6 capabilities, enabled for TLS 1.3, 
  and is 64 bit clean.
- BincIMAP 2.0.x currently supports IMAP4rev1 only. 
- BincIMAP 2.x employs the /slashpackage installation 
  but does not depend on it.
- BincIMAP uses s/qmail's authentication modules 
  to support local users together with vpopmail and vmailmgr.
- BincIMAP may announce CRAM-MD5 as additional authentication method.


MODULES:
-------
The following modules are include:

- bincimap-up 
- bincimapd
- bincimap-updatecache


ADDITIONAL SCRIPTS:
------------------
- IMAPdir2Maildir++.pl
- Maildir++2IMAPdir.pl
- checkpassword.pl
- toimapdir.pl
- tomaildir++.pl

Those need to be customized for local needs.


REQUIREMENTS:
------------
- ucspi-ssl (> 0.12.x) -- won't run without it
- ucspi-tcp6 (generating the cdb) - for IP filtering
- daemontools package (supervising the services),
  any other will do as well
- OpenSSL > 1.1.1 or LibreSSL > 3.7.0
- s/qmail 4.3 (qmail-authuser) - if using s/qmail


INSTALLATION:
------------
- Read the INSTALL document.


MAJOR INTERNAL CHANGES FROM BincIMAP 1.3.4:
------------------------------------------
- JAIL user settings removed.
- X.509 certificate and cipher handling by sslserver only.
- Removed OpenSSL code from Operator STARTTLS; replaced by sslserver's interface.
- Operator ID added (RFC 2971); requirement of Evolution client.
- CRAM-MD5 support according to RFC 2195.


BincIMAP (2.0) -- this README covers the main Binc IMAP merits.

See doc/CHANGELOG for version information.

Date: September, 12th 2023 (feh)
