/**  --------------------------------------------------------------------
 *  @file multilogdevice.h
 *  @brief Declaration of the MultilogDevice class.
 *  @author Andreas Aardal Hanssen
 *  @date Andreas Aardal Hanssen
 *  -----------------------------------------------------------------  **/
#ifndef multilogdevice_h_included
#define multilogdevice_h_included

#include "iodevice.h"

namespace Binc {
  class MultilogDevice : public IODevice {
  public:
    MultilogDevice(int flags);
    ~MultilogDevice();

    std::string service(void) const;

  protected:
    bool waitForWrite(void) const;
    bool waitForRead(void) const;

    WriteResult write(void);
    bool fillInputBuffer(void);
  };
}

#endif
